/* Require additional modules and handlers here */
//var module = require('module');
//var myCode = require('./otherModule');
//var updateHandler = require('./MyClass/update');

/**
 * This method is invoked after a oauth login succeed. It can be used to get additional data of the users oauth
 * profile. The data object will contains the data send backed form the users OAuth profile + the unique user id and
 * the API token, which can later be used to make additional API request to the providers API. By default no
 * additional profile data nor the token is saved to the baqend.
 *
 * Note: no data can be send back directly to the client by this method
 *
 * @param {baqend.EntityManager} db The database instance which can be used to load and save additional objects
 * @param {baqend.binding.User} db.User.me The unresolved user object of the logged in user
 * @param {Object} data The users OAuth profile encoded as json
 * @param {String} data.id The OAuth unique user id
 * @param {String} data.access_token The OAuth users API token
 * @param {String=} data.email The users email if the required scope was requested by the client
 * @param {express.Request} req The express request object {@link http://expressjs.com/api.html#req}
 *
 * @throws Abort(reason[, data]) to abort the oauth login
 */
exports.call = function(db, data, req) {

};