/**
 * This method is invoked if advanced GET request handling is required
 * Additional backend functionality can be implemented in such method
 *
 * Use the Response object to set the status code, additional headers and send custom response data
 *
 * @param {baqend.EntityManager} db The database instance which can be used to load and save additional objects
 * @param {baqend.binding.User} db.User.me The actual unresolved user who requests the operation or null if the user
 * is not logged in
 * @param {express.Request} req The express request object {@link http://expressjs.com/api.html#req}
 * @param {express.Response} res The express response object {@link http://expressjs.com/api.html#res}
 * @param {Object} this The module context
 * @return {Promise<*>|Object|Array|String=} A optional json value or string which is send back to the client
 *
 * @throws Abort(reason[, data]) to abort the request with the specified reason
 */
//exports.get = function(db, req, res) {
//  res.status(200).send({}); //sends back a empty json object
//};

/**
 * This method is invoked if advanced POST request handling is required
 * Additional backend functionality can be implemented in such method
 *
 * Use the Response object to set the status code, additional headers and send custom response data
 *
 * @param {baqend.EntityManager} db The database instance which can be used to load and save additional objects
 * @param {baqend.binding.User} db.User.me The actual unresolved user who requests the operation or null if the user
 * is not logged in
 * @param {express.Request} req The express request object {@link http://expressjs.com/api.html#req}
 * @param {express.Response} res The express response object {@link http://expressjs.com/api.html#res}
 * @param {Object} this The module context
 * @return {Promise<*>|Object|Array|String=} A optional json value or string which is send back to the client
 *
 * @throws Abort(reason[, data]) to abort the request with the specified reason
 */
//exports.post = function(db, req, res) {
//  res.status(200).send({}); //sends back a empty json object
//};